// To sign the product:

// run the signer script in the Release folder
// to do it - go to the folder then just run 'make'

//
//  SDWindowController.m
//  SubmarineDemo
//
//  Created by MiF on 1/30/09.
//  Copyright 2009 DeepIT. All rights reserved.
//

#import "SDWindowController.h"

#import <Submarine/Submarine.h>

@implementation SDWindowController

-(void)updateCheckTime
{
	NSDate * lastCheckDate = [[Submarine sharedSubmarine] lastCheckDate];
	if (!lastCheckDate)
		return;
	[date setStringValue:[[date formatter] stringFromDate:lastCheckDate]];
}

-(void)awakeFromNib
{
	[version setStringValue:[NSString stringWithFormat:@"Current App version is %@",
																										[[[NSBundle mainBundle] infoDictionary] valueForKey:@"CFBundleShortVersionString"]]];
	[self updateCheckTime];
}

-(IBAction)checkForUpdates:(id)sender
{
	[[Submarine sharedSubmarine] checkForUpdates:self];
	[self updateCheckTime];
}

-(IBAction)checkForUpdatesInTheBackground:(id)sender
{
	[[Submarine sharedSubmarine] checkForUpdatesInBackground:self];
	[self updateCheckTime];
}

@end
