//
//  Submarine.h
//  Submarine
//
//  Created by MiF on 1/23/09.
//  Copyright 2009 DeepIT. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "SubmarineDelegate.h"

/////////////////////////////// SETUP ////////////////////////////////////////////

// Info.plist keys
#define SUBMARINE_PLIST_VERSION_URL @"SubmarineVersionURL"
#define SUBMARINE_PLIST_CHANGES_URL @"SubmarineChangesURL"

// + SubmarineDelegate informal protocol for NSApplication inheritance (actually, target is NSApp variable)

//////////////////////////////////////////////////////////////////////////////////

// preferences keys
#define SUBMARINE_PREFS_SKIP_VERSION_KEY @"SubmarineSkipVersion"
#define SUBMARINE_PREFS_LASTCHEK_KEY @"SubmarineLastCheck"
#define SUBMARINE_PREFS_POSTINSTALL_KEY @"SubmarinePostInstall"

// version file keys
#define SUBMARINE_VERSION_KEY @"build"
#define SUBMARINE_URL_KEY @"url"
#define SUBMARINE_LENGTH_KEY @"length"
#define SUBMARINE_MD5_KEY @"md5"
// as string: 10.5, 10.4.9, 10.6.1
#define SUBMARINE_MIN_OS_KEY @"minos"

// additional system keys
#define SUBMARINE_RELAUNCHER_PATH @"relauncherPath"

// constants
#define SUBMARINE_RELAUNCHER_NAME @"Relauncher"
#define SUBMARINE_INTEGRITY @"Submarine.integrity"

@interface Submarine : NSWindowController
{
	BOOL bgCheckInProgress, downloadUpdates, finalInstallInProgress;
	NSMutableDictionary * versionDictionary;
	NSString * downloadPath;
	NSLock * downloadInProgressLock;
	unsigned received;
	int serverVersion;
}

// public
+sharedSubmarine;

-(void)checkForUpdates:(id)sender;
-(void)checkForUpdatesInBackground:(id)sender;
-(NSDate*)lastCheckDate;

@end
