//
//  SubmarineDelegate.h
//  Submarine
//
//  Created by MiF on 1/29/09.
//  Copyright 2009 DeepIT. All rights reserved.
//

#import <Cocoa/Cocoa.h>

// version dictionary - system keys

// path to an unpacked new app
#define SUBMARINE_NEWAPP @"newApp"
// path to a current app
#define SUBMARINE_CURAPP @"curApp"

// informal protocol
// note (!) : some methods may call from threads (randomly),
// so please check the current thread for more UI - thread safety
@interface NSObject (SubmarineDelegate)

// where is Info.plist with Submarine options
-(NSBundle*)submarineParentBundle;// thread unsafe

// where is the product icon/image
-(NSString*)submarineProductImagePath;// thread unsafe

// launch path for a new product if it isn't the same app
-(NSString*)submarineUpdaterPath;// thread unsafe

// YES - wants to install, NO - cancels installation
-(BOOL)submarinePreInstall:(NSMutableDictionary*)versionDictionary;// thread unsafe

// YES - show UI, NO - silent
-(BOOL)submarineInstallNewUpdate:(int)build;// thread unsafe

// after a successfull installation
-(void)submarinePostInstall;// thread safe - always calls on the main thread

@end