#!/usr/bin/perl
# (c) 2009 Deep IT, Sparkle Compatibility simple appcast gen
use strict; 

############ OPTIONS ####################
use constant PRODUCT => 'SubmarineDemo';
use constant CHANGES => 'http://deepit.ru/products/SubmarineDemo/info/changes.shtml';
use constant APPCAST => 'http://deepit.ru/products/SubmarineDemo/appcasts/SubmarineDemo.xml';
my $VERSION = './SubmarineDemo.version';
#########################################

print STDERR "\nSubmarine AppCast Gen v1.1. (c) 2009, Deep IT.\n\n";

my $tMain;
{
	undef $/;
	$tMain = <DATA>;
}

my $ver = `cat $VERSION`;

die "Invalid version file content.\n" if ($ver !~ /build/);

my %ARGS;
foreach my $option (split(/\n/,$ver))
{
	my ($arg, $val) = split(/=/,$option,2);
	$ARGS{$arg} = $val if ($arg ne '' && $val ne '');
}

sub add
{
	my ($str, $arg, $val) = @_;

	my $escArg = quotemeta('<!--' . $arg . '/-->');
	@_[0] =~ s/$escArg/$val/gs;
	return $str;
}

add($tMain,'product',PRODUCT);
add($tMain,'changes',CHANGES);
add($tMain,'appcast',APPCAST);
add($tMain,'version',$ARGS{'version'});
add($tMain,'revision',$ARGS{'build'});
add($tMain,'size',$ARGS{'length'});
add($tMain,'md5',$ARGS{'md5'});
add($tMain,'download',$ARGS{'url'});

print $tMain;

__DATA__
<?xml version="1.0" encoding="utf-8"?>
<rss version="2.0" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:sparkle="http://www.andymatuschak.org/xml-namespaces/sparkle">
 <channel>
  <title><!--product/--> Changelog</title>
  <link><!--appcast/--></link>
  <description>Most recent changes with links to updates.</description>
  <language>en</language>
  <item>  
   <title>Version <!--version/--> (<!--revision/-->)</title>
   <description><!--changes/--></description>
   <enclosure sparkle:md5Sum="<!--md5/-->" url="<!--download/-->" length="<!--size/-->"
type="application/octet-stream"/>
 </item> 
</channel>
</rss>
